Semaphore = class()

function Semaphore:init()
    self.count = 0
end

function Semaphore:signal(count)
    self.count = self.count + (count or 1)
end

function Semaphore:wait()
    while self.count == 0 do
        yieldframe()
    end
    self.count = self.count - 1
end

function Semaphore:wait_fast(timeout)
    while self.count == 0 do
        yield()
    end
    self.count = self.count - 1
end
